---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_bgp_ipv4_unicast_vrf_neighbor Data Source - terraform-provider-iosxe"
subcategory: "BGP"
description: |-
  This data source can read the BGP IPv4 Unicast VRF Neighbor configuration.
---

# iosxe_bgp_ipv4_unicast_vrf_neighbor (Data Source)

This data source can read the BGP IPv4 Unicast VRF Neighbor configuration.

## Example Usage

```terraform
data "iosxe_bgp_ipv4_unicast_vrf_neighbor" "example" {
  asn = "65000"
  vrf = "VRF1"
  ip  = "3.3.3.3"
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `ip` (String)

### Optional

- `device` (String) A device name from the provider configuration.

### Read-Only

- `activate` (Boolean) Enable the address family for this neighbor
- `asn` (String)
- `description` (String) Neighbor specific description
- `id` (String) The path of the retrieved object.
- `remote_as` (String) Specify a BGP peer-group remote-as
- `route_reflector_client` (Boolean) Configure a neighbor as Route Reflector client
- `send_community` (String)
- `shutdown` (Boolean) Administratively shut down this neighbor
- `update_source_loopback` (Number) Loopback interface
- `vrf` (String)


