---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_evpn_instance Data Source - terraform-provider-iosxe"
subcategory: "EVPN"
description: |-
  This data source can read the EVPN Instance configuration.
---

# iosxe_evpn_instance (Data Source)

This data source can read the EVPN Instance configuration.

## Example Usage

```terraform
data "iosxe_evpn_instance" "example" {
  evpn_instance_num = 10
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `evpn_instance_num` (Number) evpn instance number

### Optional

- `device` (String) A device name from the provider configuration.

### Read-Only

- `id` (String) The path of the retrieved object.
- `vlan_based_auto_route_target` (Boolean) Automatically set a route-target
- `vlan_based_default_gateway_advertise` (String) Advertise Default Gateway MAC/IP routes
- `vlan_based_encapsulation` (String) Data encapsulation method
- `vlan_based_ip_local_learning_disable` (Boolean) Disable IP local learning from dataplane
- `vlan_based_ip_local_learning_enable` (Boolean) Enable IP local learning from dataplane
- `vlan_based_rd` (String) ASN:nn or IP-address:nn
- `vlan_based_re_originate_route_type5` (Boolean) Re-originate route-type 5
- `vlan_based_replication_type_ingress` (Boolean) Ingress replication
- `vlan_based_replication_type_mp2mp` (Boolean) mp2mp replication
- `vlan_based_replication_type_p2mp` (Boolean) p2mp replication
- `vlan_based_replication_type_static` (Boolean) Static replication
- `vlan_based_route_target` (String) ASN:nn or IP-address:nn
- `vlan_based_route_target_both` (String) ASN:nn or IP-address:nn
- `vlan_based_route_target_export` (String) ASN:nn or IP-address:nn
- `vlan_based_route_target_import` (String) ASN:nn or IP-address:nn


