---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_banner Resource - terraform-provider-iosxe"
subcategory: "System"
description: |-
  This resource can manage the Banner configuration.
---

# iosxe_banner (Resource)

This resource can manage the Banner configuration.

## Example Usage

```terraform
resource "iosxe_banner" "example" {
  exec_banner           = "My Exec Banner"
  login_banner          = "My Login Banner"
  prompt_timeout_banner = "My Prompt-Timeout Banner"
  motd_banner           = "My MOTD Banner"
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Optional

- `device` (String) A device name from the provider configuration.
- `exec_banner` (String) Banner message
- `login_banner` (String) Banner message
- `motd_banner` (String) Banner message
- `prompt_timeout_banner` (String) Banner message

### Read-Only

- `id` (String) The path of the object.

## Import

Import is supported using the following syntax:

```shell
terraform import iosxe_banner.example "Cisco-IOS-XE-native:native/banner"
```
