---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_bgp Resource - terraform-provider-iosxe"
subcategory: "BGP"
description: |-
  This resource can manage the BGP configuration.
---

# iosxe_bgp (Resource)

This resource can manage the BGP configuration.

## Example Usage

```terraform
resource "iosxe_bgp" "example" {
  asn                  = "65000"
  default_ipv4_unicast = false
  log_neighbor_changes = true
  router_id_loopback   = 100
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `asn` (String)

### Optional

- `default_ipv4_unicast` (Boolean) Activate ipv4-unicast for a peer by default
- `device` (String) A device name from the provider configuration.
- `log_neighbor_changes` (Boolean) Log neighbor up/down and reset reason
- `router_id_loopback` (Number) Loopback interface
  - Range: `0`-`2147483647`

### Read-Only

- `id` (String) The path of the object.

## Import

Import is supported using the following syntax:

```shell
terraform import iosxe_bgp.example "Cisco-IOS-XE-native:native/router/Cisco-IOS-XE-bgp:bgp=65000"
```
