---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_bgp_ipv4_unicast_vrf_neighbor Resource - terraform-provider-iosxe"
subcategory: "BGP"
description: |-
  This resource can manage the BGP IPv4 Unicast VRF Neighbor configuration.
---

# iosxe_bgp_ipv4_unicast_vrf_neighbor (Resource)

This resource can manage the BGP IPv4 Unicast VRF Neighbor configuration.

## Example Usage

```terraform
resource "iosxe_bgp_ipv4_unicast_vrf_neighbor" "example" {
  asn                    = "65000"
  vrf                    = "VRF1"
  ip                     = "3.3.3.3"
  remote_as              = "65000"
  description            = "BGP Neighbor Description"
  shutdown               = false
  update_source_loopback = 100
  activate               = true
  send_community         = "both"
  route_reflector_client = false
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `asn` (String)
- `ip` (String)
- `vrf` (String)

### Optional

- `activate` (Boolean) Enable the address family for this neighbor
- `description` (String) Neighbor specific description
- `device` (String) A device name from the provider configuration.
- `remote_as` (String) Specify a BGP peer-group remote-as
- `route_reflector_client` (Boolean) Configure a neighbor as Route Reflector client
- `send_community` (String) - Choices: `both`, `extended`, `standard`
- `shutdown` (Boolean) Administratively shut down this neighbor
- `update_source_loopback` (Number) Loopback interface

### Read-Only

- `id` (String) The path of the object.

## Import

Import is supported using the following syntax:

```shell
terraform import iosxe_bgp_ipv4_unicast_vrf_neighbor.example "Cisco-IOS-XE-native:native/router/Cisco-IOS-XE-bgp:bgp=65000/address-family/with-vrf/ipv4=unicast/vrf=VRF1/ipv4-unicast/neighbor=3.3.3.3"
```
