---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_bgp_l2vpn_evpn_neighbor Resource - terraform-provider-iosxe"
subcategory: "BGP"
description: |-
  This resource can manage the BGP L2VPN EVPN Neighbor configuration.
---

# iosxe_bgp_l2vpn_evpn_neighbor (Resource)

This resource can manage the BGP L2VPN EVPN Neighbor configuration.

## Example Usage

```terraform
resource "iosxe_bgp_l2vpn_evpn_neighbor" "example" {
  asn                    = "65000"
  ip                     = "3.3.3.3"
  activate               = true
  send_community         = "both"
  route_reflector_client = false
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `asn` (String)
- `ip` (String)

### Optional

- `activate` (Boolean) Enable the address family for this neighbor
- `device` (String) A device name from the provider configuration.
- `route_reflector_client` (Boolean) Configure a neighbor as Route Reflector client
- `send_community` (String) - Choices: `both`, `extended`, `standard`

### Read-Only

- `id` (String) The path of the object.

## Import

Import is supported using the following syntax:

```shell
terraform import iosxe_bgp_l2vpn_evpn_neighbor.example "Cisco-IOS-XE-native:native/router/Cisco-IOS-XE-bgp:bgp=65000/address-family/no-vrf/l2vpn=evpn/l2vpn-evpn/neighbor=3.3.3.3"
```
