---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_evpn Resource - terraform-provider-iosxe"
subcategory: "EVPN"
description: |-
  This resource can manage the EVPN configuration.
---

# iosxe_evpn (Resource)

This resource can manage the EVPN configuration.

## Example Usage

```terraform
resource "iosxe_evpn" "example" {
  replication_type_ingress  = false
  replication_type_static   = true
  replication_type_p2mp     = false
  replication_type_mp2mp    = false
  mac_duplication_limit     = 10
  mac_duplication_time      = 100
  ip_duplication_limit      = 10
  ip_duplication_time       = 100
  router_id_loopback        = 100
  default_gateway_advertise = true
  logging_peer_state        = true
  route_target_auto_vni     = true
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Optional

- `default_gateway_advertise` (Boolean) Advertise Default Gateway MAC/IP routes
- `device` (String) A device name from the provider configuration.
- `ip_duplication_limit` (Number) Number of IP moves within specified time interval
  - Range: `2`-`1000`
- `ip_duplication_time` (Number) IP duplication timer
  - Range: `10`-`36000`
- `logging_peer_state` (Boolean) Peer state transition logging
- `mac_duplication_limit` (Number) Number of MAC moves within specified time interval
  - Range: `2`-`1000`
- `mac_duplication_time` (Number) MAC duplication timer
  - Range: `10`-`36000`
- `replication_type_ingress` (Boolean) Ingress replication
- `replication_type_mp2mp` (Boolean) mp2mp replication
- `replication_type_p2mp` (Boolean) p2mp replication
- `replication_type_static` (Boolean) Static replication
- `route_target_auto_vni` (Boolean) Set vni-based route-target
- `router_id_loopback` (Number) Loopback interface
  - Range: `0`-`2147483647`

### Read-Only

- `id` (String) The path of the object.

## Import

Import is supported using the following syntax:

```shell
terraform import iosxe_evpn.example "Cisco-IOS-XE-native:native/l2vpn/Cisco-IOS-XE-l2vpn:evpn_cont/evpn"
```
