// Code generated by "gen/generator.go"; DO NOT EDIT.

package provider

import (
	"testing"

	"github.com/hashicorp/terraform-plugin-sdk/v2/helper/resource"
)

func TestAccDataSourceIosxeBGPNeighbor(t *testing.T) {
	resource.Test(t, resource.TestCase{
		PreCheck:                 func() { testAccPreCheck(t) },
		ProtoV6ProviderFactories: testAccProtoV6ProviderFactories,
		Steps: []resource.TestStep{
			{
				Config: testAccDataSourceIosxeBGPNeighborPrerequisitesConfig + testAccDataSourceIosxeBGPNeighborConfig,
				Check: resource.ComposeTestCheckFunc(
					resource.TestCheckResourceAttr("data.iosxe_bgp_neighbor.test", "remote_as", "65000"),
					resource.TestCheckResourceAttr("data.iosxe_bgp_neighbor.test", "description", "BGP Neighbor Description"),
					resource.TestCheckResourceAttr("data.iosxe_bgp_neighbor.test", "shutdown", "false"),
					resource.TestCheckResourceAttr("data.iosxe_bgp_neighbor.test", "update_source_loopback", "100"),
				),
			},
		},
	})
}

const testAccDataSourceIosxeBGPNeighborPrerequisitesConfig = `
resource "iosxe_restconf" "PreReq0" {
  path = "Cisco-IOS-XE-native:native/router/Cisco-IOS-XE-bgp:bgp=65000"
  attributes = {
      id = "65000"
  }
}

resource "iosxe_restconf" "PreReq1" {
  path = "Cisco-IOS-XE-native:native/interface/Loopback=100"
  attributes = {
      name = "100"
  }
}

`

const testAccDataSourceIosxeBGPNeighborConfig = `

resource "iosxe_bgp_neighbor" "test" {
  asn = "65000"
  ip = "3.3.3.3"
  remote_as = "65000"
  description = "BGP Neighbor Description"
  shutdown = false
  update_source_loopback = 100
  depends_on = [iosxe_restconf.PreReq0, iosxe_restconf.PreReq1, ]
}

data "iosxe_bgp_neighbor" "test" {
  asn = "65000"
  ip = "3.3.3.3"
  depends_on = [iosxe_bgp_neighbor.test]
}
`
