// Code generated by "gen/generator.go"; DO NOT EDIT.

package provider

import (
	"context"
	"fmt"

	"github.com/hashicorp/terraform-plugin-framework/diag"
	"github.com/hashicorp/terraform-plugin-framework/tfsdk"
	"github.com/hashicorp/terraform-plugin-framework/types"
	"github.com/hashicorp/terraform-plugin-log/tflog"
)

type dataSourceInterfaceNVEType struct{}

func (t dataSourceInterfaceNVEType) GetSchema(ctx context.Context) (tfsdk.Schema, diag.Diagnostics) {
	return tfsdk.Schema{
		// This description is used by the documentation generator and the language server.
		MarkdownDescription: "This data source can read the Interface NVE configuration.",

		Attributes: map[string]tfsdk.Attribute{
			"device": {
				MarkdownDescription: "A device name from the provider configuration.",
				Type:                types.StringType,
				Optional:            true,
			},
			"id": {
				MarkdownDescription: "The path of the retrieved object.",
				Type:                types.StringType,
				Computed:            true,
			},
			"name": {
				MarkdownDescription: "",
				Type:                types.Int64Type,
				Required:            true,
			},
			"description": {
				MarkdownDescription: "Interface specific description",
				Type:                types.StringType,
				Computed:            true,
			},
			"shutdown": {
				MarkdownDescription: "Shutdown the selected interface",
				Type:                types.BoolType,
				Computed:            true,
			},
			"host_reachability_protocol_bgp": {
				MarkdownDescription: "",
				Type:                types.BoolType,
				Computed:            true,
			},
			"source_interface_loopback": {
				MarkdownDescription: "Loopback interface",
				Type:                types.Int64Type,
				Computed:            true,
			},
			"vni_vrfs": {
				MarkdownDescription: "Configure VNI information",
				Computed:            true,
				Attributes: tfsdk.ListNestedAttributes(map[string]tfsdk.Attribute{
					"vni_range": {
						MarkdownDescription: "VNI range or instance between 4096-16777215, example: 6010-6030 or 7115",
						Type:                types.StringType,
						Computed:            true,
					},
					"vrf": {
						MarkdownDescription: "Specify a particular VRF",
						Type:                types.StringType,
						Computed:            true,
					},
				}, tfsdk.ListNestedAttributesOptions{}),
			},
			"vnis": {
				MarkdownDescription: "Configure VNI information",
				Computed:            true,
				Attributes: tfsdk.ListNestedAttributes(map[string]tfsdk.Attribute{
					"vni_range": {
						MarkdownDescription: "VNI range or instance between 4096-16777215, example: 6010-6030 or 7115",
						Type:                types.StringType,
						Computed:            true,
					},
					"ipv4_multicast_group": {
						MarkdownDescription: "Starting Multicast Group IPv4 Address",
						Type:                types.StringType,
						Computed:            true,
					},
					"ingress_replication": {
						MarkdownDescription: "Ingress Replication control-plane (BGP) signaling",
						Type:                types.BoolType,
						Computed:            true,
					},
				}, tfsdk.ListNestedAttributesOptions{}),
			},
		},
	}, nil
}

func (t dataSourceInterfaceNVEType) NewDataSource(ctx context.Context, in tfsdk.Provider) (tfsdk.DataSource, diag.Diagnostics) {
	provider, diags := convertProviderType(in)

	return dataSourceInterfaceNVE{
		provider: provider,
	}, diags
}

type dataSourceInterfaceNVE struct {
	provider provider
}

func (d dataSourceInterfaceNVE) Read(ctx context.Context, req tfsdk.ReadDataSourceRequest, resp *tfsdk.ReadDataSourceResponse) {
	var config, state InterfaceNVE

	// Read config
	diags := req.Config.Get(ctx, &config)
	resp.Diagnostics.Append(diags...)
	if resp.Diagnostics.HasError() {
		return
	}

	tflog.Debug(ctx, fmt.Sprintf("%s: Beginning Read", config.getPath()))

	res, err := d.provider.clients[config.Device.Value].GetData(config.getPath())
	if res.StatusCode == 404 {
		state = InterfaceNVE{Device: config.Device}
	} else {
		if err != nil {
			resp.Diagnostics.AddError("Client Error", fmt.Sprintf("Failed to retrieve object, got error: %s", err))
			return
		}

		state.fromBody(res.Res)
	}

	state.Id = types.String{Value: config.getPath()}

	tflog.Debug(ctx, fmt.Sprintf("%s: Read finished successfully", config.getPath()))

	diags = resp.State.Set(ctx, &state)
	resp.Diagnostics.Append(diags...)
}
