// Code generated by "gen/generator.go"; DO NOT EDIT.

package provider

import (
	"regexp"

	"github.com/hashicorp/terraform-plugin-framework/types"
	"github.com/netascode/terraform-provider-iosxe/internal/provider/helpers"
	"github.com/tidwall/gjson"
	"github.com/tidwall/sjson"
)

type Banner struct {
	Device              types.String `tfsdk:"device"`
	Id                  types.String `tfsdk:"id"`
	ExecBanner          types.String `tfsdk:"exec_banner"`
	LoginBanner         types.String `tfsdk:"login_banner"`
	PromptTimeoutBanner types.String `tfsdk:"prompt_timeout_banner"`
	MotdBanner          types.String `tfsdk:"motd_banner"`
}

func (data Banner) getPath() string {
	return "Cisco-IOS-XE-native:native/banner"
}

// if last path element has a key -> remove it
func (data Banner) getPathShort() string {
	path := data.getPath()
	re := regexp.MustCompile(`(.*)=[^\/]*$`)
	matches := re.FindStringSubmatch(path)
	if len(matches) <= 1 {
		return path
	}
	return matches[1]
}

func (data Banner) toBody() string {
	body := `{"` + helpers.LastElement(data.getPath()) + `":{}}`
	if !data.ExecBanner.Null && !data.ExecBanner.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"exec.banner", data.ExecBanner.Value)
	}
	if !data.LoginBanner.Null && !data.LoginBanner.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"login.banner", data.LoginBanner.Value)
	}
	if !data.PromptTimeoutBanner.Null && !data.PromptTimeoutBanner.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"prompt-timeout.banner", data.PromptTimeoutBanner.Value)
	}
	if !data.MotdBanner.Null && !data.MotdBanner.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"motd.banner", data.MotdBanner.Value)
	}
	return body
}

func (data *Banner) updateFromBody(res gjson.Result) {
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "exec.banner"); value.Exists() {
		data.ExecBanner.Value = value.String()
	} else {
		data.ExecBanner.Null = true
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "login.banner"); value.Exists() {
		data.LoginBanner.Value = value.String()
	} else {
		data.LoginBanner.Null = true
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "prompt-timeout.banner"); value.Exists() {
		data.PromptTimeoutBanner.Value = value.String()
	} else {
		data.PromptTimeoutBanner.Null = true
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "motd.banner"); value.Exists() {
		data.MotdBanner.Value = value.String()
	} else {
		data.MotdBanner.Null = true
	}
}

func (data *Banner) fromBody(res gjson.Result) {
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "exec.banner"); value.Exists() {
		data.ExecBanner.Value = value.String()
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "login.banner"); value.Exists() {
		data.LoginBanner.Value = value.String()
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "prompt-timeout.banner"); value.Exists() {
		data.PromptTimeoutBanner.Value = value.String()
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "motd.banner"); value.Exists() {
		data.MotdBanner.Value = value.String()
	}
}

func (data *Banner) setUnknownValues() {
	if data.Device.Unknown {
		data.Device.Unknown = false
		data.Device.Null = true
	}
	if data.Id.Unknown {
		data.Id.Unknown = false
		data.Id.Null = true
	}
	if data.ExecBanner.Unknown {
		data.ExecBanner.Unknown = false
		data.ExecBanner.Null = true
	}
	if data.LoginBanner.Unknown {
		data.LoginBanner.Unknown = false
		data.LoginBanner.Null = true
	}
	if data.PromptTimeoutBanner.Unknown {
		data.PromptTimeoutBanner.Unknown = false
		data.PromptTimeoutBanner.Null = true
	}
	if data.MotdBanner.Unknown {
		data.MotdBanner.Unknown = false
		data.MotdBanner.Null = true
	}
}

func (data *Banner) getDeletedListItems(state Banner) []string {
	deletedListItems := make([]string, 0)
	return deletedListItems
}
