// Code generated by "gen/generator.go"; DO NOT EDIT.

package provider

import (
	"fmt"
	"regexp"

	"github.com/hashicorp/terraform-plugin-framework/types"
	"github.com/netascode/terraform-provider-iosxe/internal/provider/helpers"
	"github.com/tidwall/gjson"
	"github.com/tidwall/sjson"
)

type BGPAddressFamilyL2VPN struct {
	Device types.String `tfsdk:"device"`
	Id     types.String `tfsdk:"id"`
	Asn    types.String `tfsdk:"asn"`
	AfName types.String `tfsdk:"af_name"`
}

func (data BGPAddressFamilyL2VPN) getPath() string {
	return fmt.Sprintf("Cisco-IOS-XE-native:native/router/Cisco-IOS-XE-bgp:bgp=%v/address-family/no-vrf/l2vpn=%s", data.Asn.Value, data.AfName.Value)
}

// if last path element has a key -> remove it
func (data BGPAddressFamilyL2VPN) getPathShort() string {
	path := data.getPath()
	re := regexp.MustCompile(`(.*)=[^\/]*$`)
	matches := re.FindStringSubmatch(path)
	if len(matches) <= 1 {
		return path
	}
	return matches[1]
}

func (data BGPAddressFamilyL2VPN) toBody() string {
	body := `{"` + helpers.LastElement(data.getPath()) + `":{}}`
	if !data.AfName.Null && !data.AfName.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"af-name", data.AfName.Value)
	}
	return body
}

func (data *BGPAddressFamilyL2VPN) updateFromBody(res gjson.Result) {
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "af-name"); value.Exists() {
		data.AfName.Value = value.String()
	} else {
		data.AfName.Null = true
	}
}

func (data *BGPAddressFamilyL2VPN) fromBody(res gjson.Result) {
}

func (data *BGPAddressFamilyL2VPN) setUnknownValues() {
	if data.Device.Unknown {
		data.Device.Unknown = false
		data.Device.Null = true
	}
	if data.Id.Unknown {
		data.Id.Unknown = false
		data.Id.Null = true
	}
	if data.Asn.Unknown {
		data.Asn.Unknown = false
		data.Asn.Null = true
	}
	if data.AfName.Unknown {
		data.AfName.Unknown = false
		data.AfName.Null = true
	}
}

func (data *BGPAddressFamilyL2VPN) getDeletedListItems(state BGPAddressFamilyL2VPN) []string {
	deletedListItems := make([]string, 0)
	return deletedListItems
}
