// Code generated by "gen/generator.go"; DO NOT EDIT.

package provider

import (
	"fmt"
	"regexp"
	"strconv"

	"github.com/hashicorp/terraform-plugin-framework/types"
	"github.com/netascode/terraform-provider-iosxe/internal/provider/helpers"
	"github.com/tidwall/gjson"
	"github.com/tidwall/sjson"
)

type BGPIPv4UnicastVRFNeighbor struct {
	Device               types.String `tfsdk:"device"`
	Id                   types.String `tfsdk:"id"`
	Asn                  types.String `tfsdk:"asn"`
	Vrf                  types.String `tfsdk:"vrf"`
	Ip                   types.String `tfsdk:"ip"`
	RemoteAs             types.String `tfsdk:"remote_as"`
	Description          types.String `tfsdk:"description"`
	Shutdown             types.Bool   `tfsdk:"shutdown"`
	UpdateSourceLoopback types.Int64  `tfsdk:"update_source_loopback"`
	Activate             types.Bool   `tfsdk:"activate"`
	SendCommunity        types.String `tfsdk:"send_community"`
	RouteReflectorClient types.Bool   `tfsdk:"route_reflector_client"`
}

func (data BGPIPv4UnicastVRFNeighbor) getPath() string {
	return fmt.Sprintf("Cisco-IOS-XE-native:native/router/Cisco-IOS-XE-bgp:bgp=%v/address-family/with-vrf/ipv4=unicast/vrf=%s/ipv4-unicast/neighbor=%s", data.Asn.Value, data.Vrf.Value, data.Ip.Value)
}

// if last path element has a key -> remove it
func (data BGPIPv4UnicastVRFNeighbor) getPathShort() string {
	path := data.getPath()
	re := regexp.MustCompile(`(.*)=[^\/]*$`)
	matches := re.FindStringSubmatch(path)
	if len(matches) <= 1 {
		return path
	}
	return matches[1]
}

func (data BGPIPv4UnicastVRFNeighbor) toBody() string {
	body := `{"` + helpers.LastElement(data.getPath()) + `":{}}`
	if !data.Ip.Null && !data.Ip.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"id", data.Ip.Value)
	}
	if !data.RemoteAs.Null && !data.RemoteAs.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"remote-as", data.RemoteAs.Value)
	}
	if !data.Description.Null && !data.Description.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"description", data.Description.Value)
	}
	if !data.Shutdown.Null && !data.Shutdown.Unknown {
		if data.Shutdown.Value {
			body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"shutdown", map[string]string{})
		}
	}
	if !data.UpdateSourceLoopback.Null && !data.UpdateSourceLoopback.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"update-source.interface.Loopback", strconv.FormatInt(data.UpdateSourceLoopback.Value, 10))
	}
	if !data.Activate.Null && !data.Activate.Unknown {
		if data.Activate.Value {
			body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"activate", map[string]string{})
		}
	}
	if !data.SendCommunity.Null && !data.SendCommunity.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"send-community.send-community-where", data.SendCommunity.Value)
	}
	if !data.RouteReflectorClient.Null && !data.RouteReflectorClient.Unknown {
		if data.RouteReflectorClient.Value {
			body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"route-reflector-client", map[string]string{})
		}
	}
	return body
}

func (data *BGPIPv4UnicastVRFNeighbor) updateFromBody(res gjson.Result) {
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "id"); value.Exists() {
		data.Ip.Value = value.String()
	} else {
		data.Ip.Null = true
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "remote-as"); value.Exists() {
		data.RemoteAs.Value = value.String()
	} else {
		data.RemoteAs.Null = true
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "description"); value.Exists() {
		data.Description.Value = value.String()
	} else {
		data.Description.Null = true
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "shutdown"); value.Exists() {
		data.Shutdown.Value = true
	} else {
		data.Shutdown.Value = false
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "update-source.interface.Loopback"); value.Exists() {
		data.UpdateSourceLoopback.Value = value.Int()
	} else {
		data.UpdateSourceLoopback.Null = true
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "activate"); value.Exists() {
		data.Activate.Value = true
	} else {
		data.Activate.Value = false
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "send-community.send-community-where"); value.Exists() {
		data.SendCommunity.Value = value.String()
	} else {
		data.SendCommunity.Null = true
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "route-reflector-client"); value.Exists() {
		data.RouteReflectorClient.Value = true
	} else {
		data.RouteReflectorClient.Value = false
	}
}

func (data *BGPIPv4UnicastVRFNeighbor) fromBody(res gjson.Result) {
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "remote-as"); value.Exists() {
		data.RemoteAs.Value = value.String()
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "description"); value.Exists() {
		data.Description.Value = value.String()
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "shutdown"); value.Exists() {
		data.Shutdown.Value = true
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "update-source.interface.Loopback"); value.Exists() {
		data.UpdateSourceLoopback.Value = value.Int()
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "activate"); value.Exists() {
		data.Activate.Value = true
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "send-community.send-community-where"); value.Exists() {
		data.SendCommunity.Value = value.String()
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "route-reflector-client"); value.Exists() {
		data.RouteReflectorClient.Value = true
	}
}

func (data *BGPIPv4UnicastVRFNeighbor) setUnknownValues() {
	if data.Device.Unknown {
		data.Device.Unknown = false
		data.Device.Null = true
	}
	if data.Id.Unknown {
		data.Id.Unknown = false
		data.Id.Null = true
	}
	if data.Asn.Unknown {
		data.Asn.Unknown = false
		data.Asn.Null = true
	}
	if data.Vrf.Unknown {
		data.Vrf.Unknown = false
		data.Vrf.Null = true
	}
	if data.Ip.Unknown {
		data.Ip.Unknown = false
		data.Ip.Null = true
	}
	if data.RemoteAs.Unknown {
		data.RemoteAs.Unknown = false
		data.RemoteAs.Null = true
	}
	if data.Description.Unknown {
		data.Description.Unknown = false
		data.Description.Null = true
	}
	if data.Shutdown.Unknown {
		data.Shutdown.Unknown = false
		data.Shutdown.Null = true
	}
	if data.UpdateSourceLoopback.Unknown {
		data.UpdateSourceLoopback.Unknown = false
		data.UpdateSourceLoopback.Null = true
	}
	if data.Activate.Unknown {
		data.Activate.Unknown = false
		data.Activate.Null = true
	}
	if data.SendCommunity.Unknown {
		data.SendCommunity.Unknown = false
		data.SendCommunity.Null = true
	}
	if data.RouteReflectorClient.Unknown {
		data.RouteReflectorClient.Unknown = false
		data.RouteReflectorClient.Null = true
	}
}

func (data *BGPIPv4UnicastVRFNeighbor) getDeletedListItems(state BGPIPv4UnicastVRFNeighbor) []string {
	deletedListItems := make([]string, 0)
	return deletedListItems
}
