// Code generated by "gen/generator.go"; DO NOT EDIT.

package provider

import (
	"testing"

	"github.com/hashicorp/terraform-plugin-sdk/v2/helper/resource"
)

func TestAccIosxeBGP(t *testing.T) {
	resource.Test(t, resource.TestCase{
		PreCheck:                 func() { testAccPreCheck(t) },
		ProtoV6ProviderFactories: testAccProtoV6ProviderFactories,
		Steps: []resource.TestStep{
			{
				Config: testAccIosxeBGPPrerequisitesConfig + testAccIosxeBGPConfig_all(),
				Check: resource.ComposeTestCheckFunc(
					resource.TestCheckResourceAttr("iosxe_bgp.test", "asn", "65000"),
					resource.TestCheckResourceAttr("iosxe_bgp.test", "default_ipv4_unicast", "false"),
					resource.TestCheckResourceAttr("iosxe_bgp.test", "log_neighbor_changes", "true"),
					resource.TestCheckResourceAttr("iosxe_bgp.test", "router_id_loopback", "100"),
				),
			},
			{
				ResourceName:  "iosxe_bgp.test",
				ImportState:   true,
				ImportStateId: "Cisco-IOS-XE-native:native/router/Cisco-IOS-XE-bgp:bgp=65000",
			},
		},
	})
}

const testAccIosxeBGPPrerequisitesConfig = `
resource "iosxe_restconf" "PreReq0" {
  path = "Cisco-IOS-XE-native:native/interface/Loopback=100"
  attributes = {
      name = "100"
  }
}

resource "iosxe_restconf" "PreReq1" {
  path = "Cisco-IOS-XE-native:native/interface/Loopback=100/ip/address/primary"
  attributes = {
      address = "200.200.200.200"
      mask = "255.255.255.255"
  }
  depends_on = [iosxe_restconf.PreReq0, ]
}

`

func testAccIosxeBGPConfig_minimum() string {
	return `
	resource "iosxe_bgp" "test" {
		asn = "65000"
  		depends_on = [iosxe_restconf.PreReq0, iosxe_restconf.PreReq1, ]
	}
	`
}

func testAccIosxeBGPConfig_all() string {
	return `
	resource "iosxe_bgp" "test" {
		asn = "65000"
		default_ipv4_unicast = false
		log_neighbor_changes = true
		router_id_loopback = 100
  		depends_on = [iosxe_restconf.PreReq0, iosxe_restconf.PreReq1, ]
	}
	`
}
